=== debian/changelog ===
fpzip (1.3.0-6) unstable; urgency=medium

  * cmake-version.patch: Fix FTBFS with CMake 4. Closes: #1112929
  * Standards-Version: 4.7.2

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 01 Sep 2025 10:34:20 +0100

fpzip (1.3.0-5) unstable; urgency=medium

  * Set Debian Science Maint. as maintainer
  * Fix broken vcs url
  * Standards-Version: 4.7.0; no changes required
  * Drop B-D on dh-buildinfo

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 14 Feb 2025 10:22:48 +0000

fpzip (1.3.0-4) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use versioned copyright format URI.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Fix broken Vcs URL.

  [ Alastair McKinstry ]
  * Standards-Version: 4.6.2
  * Set architecture-is-64-bit, tests fail on 32-bit. Closes: #1068067

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 02 Apr 2024 11:37:03 +0100

fpzip (1.3.0-3) unstable; urgency=medium

  * Define int64/uint64 for 32-bit arch build failures
  * Standards-Version: 4.6.0

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 21 Apr 2022 11:16:41 +0100

fpzip (1.3.0-2) unstable; urgency=medium

  * Set libpath so test will build without libfpzip installed.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 26 Jan 2021 09:31:17 +0000

fpzip (1.3.0-1) unstable; urgency=medium

  * Initial release. (Closes: #980113)

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 15 Jan 2021 11:27:56 +0000
