=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1


# The magic debhelper  rule
%:
	dh $@ --buildsystem=cmake

DESTDIR=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
TARGET_ARCH:= $(shell dpkg-architecture -qDEB_TARGET_GNU_TYPE)

export LD_LIBRARY_PATH:=$(CURDIR)/obj-$(TARGET_ARCH)/lib/$(DEB_HOST_MULTIARCH):$(LD_LIBRARY_PATH)

ARCH32:= powerpc armel armhf i386 mipsel m68k mips powerpcspe x32
LONG_32BIT:=     $(if $(filter $(DEB_TARGET_ARCH), $(PATCH_ON_32BIT_ARCH)),\
                -DFPZIP_INT64='long long' \
                -DFPZIP_UINT64='long long' \
                -DFPZIP_INT64_SUFFIX='ll' \
                -DFPZIP_UINT64_SUFFIX='ull' , )

override_dh_auto_configure:
	dh_auto_configure -- \
		-DBUILD_ALL=On \
		$(LONG_32BIT) \
		-DCMAKE_SKIP_INSTALL_RPATH=On \
		-DCMAKE_SKIP_RPATH=On
