=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/(\d\S+)\.tar\.gz/$1\.tar\.gz/ \
  https://github.com/LLNL/fpzip/tags .*/(\d\S+)\.tar\.gz
